import java.io.*;
import java.lang.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class MatexRechnerME extends MIDlet implements CommandListener
{

	private Display display;

	Form screen;
	String url =
		"http://www.mycgiserver.com/servlet/joseflueth.MatexCalcMEServlet?term=";
	Command calculateCommand,
		exitCommand,
		addPlus,
		addMinus,
		addMultiply,
		addDivide,
		addPower,
		addPi,
		addE,
		addParentOpen,
		addParentClose,
		helpCommand,
		infoCommand;
	TextField termField;
	StringItem result = new StringItem("", "");

	public MatexRechnerME()
	{
		display = Display.getDisplay(this);
		calculateCommand = new Command("Berechnen", Command.OK, 0);
		exitCommand = new Command("Beenden", Command.EXIT, 0);
		addPlus = new Command("Addition einfgen", Command.OK, 0);
		addMinus = new Command("Subtraktion einfgen", Command.OK, 0);
		addMultiply = new Command("Multiplikation einfgen", Command.OK, 0);
		addDivide = new Command("Division einfgen", Command.OK, 0);
		addPower = new Command("Potenzrechnung einfgen", Command.OK, 0);
		addPi = new Command("Pi einfgen", Command.OK, 0);
		addE = new Command("e einfgen", Command.OK, 0);
		addParentOpen = new Command("'Klammer auf' einfgen", Command.OK, 0);
		addParentClose = new Command("'Klammer zu' einfgen", Command.OK, 0);
		helpCommand = new Command("Hilfe", Command.OK, 0);
		infoCommand = new Command("Info", Command.OK, 0);
		termField = new TextField("term", "", 30, TextField.ANY);
		termField.setLabel("Term");
		screen = new Form("Matex Rechner 1.0 ME");
	}

	/**
	 * This will be invoked when we start the MIDlet
	 */
	public void startApp()
	{
		screen.addCommand(exitCommand);
		screen.addCommand(calculateCommand);
		screen.addCommand(addPlus);
		screen.addCommand(addMinus);
		screen.addCommand(addMultiply);
		screen.addCommand(addDivide);
		screen.addCommand(addPower);
		screen.addCommand(addPi);
		screen.addCommand(addE);
		screen.addCommand(addParentOpen);
		screen.addCommand(addParentClose);
		screen.addCommand(helpCommand);
		screen.addCommand(infoCommand);
		screen.append(termField);
		screen.append(result);
		screen.setCommandListener(this);
		display.setCurrent(screen);

	}
	public void commandAction(Command c, Displayable s)
	{
		if (c == exitCommand)
		{
			destroyApp(false);
			notifyDestroyed();
		}
		if (c == calculateCommand)
		{
			Thread t = new Thread()
			{
				public void run()
				{
					try
					{
						getResult(url);
					}
					catch (IOException e)
					{
						//Handle Exceptions any other way you like.
						System.out.println("IOException " + e);
						e.printStackTrace();
					}
				}
			};
			t.start();

		}
		if (c == addPlus)
			termField.setString(termField.getString() + "+");
		if (c == addMinus)
			termField.setString(termField.getString() + "-");
		if (c == addMultiply)
			termField.setString(termField.getString() + "*");
		if (c == addDivide)
			termField.setString(termField.getString() + "/");
		if (c == addPower)
			termField.setString(termField.getString() + "^");
		if (c == addPi)
			termField.setString(termField.getString() + "!pi");
		if (c == addE)
			termField.setString(termField.getString() + "!e");
		if (c == addParentOpen)
			termField.setString(termField.getString() + "(");
		if (c == addParentClose)
			termField.setString(termField.getString() + ")");
		if (c == helpCommand)
		{
			Alert hilfe = new Alert("Hilfe");
			hilfe.setTimeout(-2);
			hilfe.setType(AlertType.INFO);
			hilfe.setString(
				"Beim Eingeben von Zahlen und Variablen knnen Sie die Tastertur verwenden."
					+ " Operationszeichen knnen Sie ber das Men einfgen. Beachten Sie,"
					+ " dass die Schreibweise z.B. beim Potenzieren so aus sieht: Basis^Pozen."
					+ " Fr die Ermittlung des Ergebnisses muss eine Internetverbindung aufgebaut werden.");
			display.setCurrent(hilfe);
		}
		if (c == infoCommand)
		{
			Alert info = new Alert("Info");
			info.setTimeout(-2);
			info.setType(AlertType.INFO);
			info.setString(
				"Matex Rechner 1.0 Mobile Edition Autor: Josef Lth Download: matexSoft.com");
			display.setCurrent(info);
		}
	}

	/**
	 * Pause, discontinue ....
	 */
	public void pauseApp()
	{

	}

	/**
	 * Destroy must cleanup everything.  
	 */
	public void destroyApp(boolean unconditional)
	{
	}

	/**
	 * read url via stream connection
	 */
	void getResult(String url) throws IOException
	{
		result.setText("Ergebnis wird ermittelt...");
		StreamConnection c = null;
		InputStream s = null;
		StringBuffer b = new StringBuffer();
		TextBox t = null;
		try
		{
			url = url + encodeURL(termField.getString());
			c = (StreamConnection) Connector.open(url);
			s = c.openInputStream();
			int ch;
			while ((ch = s.read()) != -1)
			{
				b.append((char) ch);
			}
			result.setText(b.toString());
		}
		catch (Exception e)
		{
			System.out.println(e.getMessage());
			result.setText("");
		}
		finally
		{
			if (s != null)
			{
				s.close();
			}
			if (c != null)
			{
				c.close();
			}
		}
		// display the contents of the file in a text box.
		display.setCurrent(t);
	}

	public String encodeURL(String url)
	{
		String newURL = "";
		char d[] = url.toCharArray();
		for (int i = 0; i < d.length; i++)
		{
			if (d[i] == "+".toCharArray()[0])
				newURL = newURL + "%2B";
			else
				if (d[i] == "/".toCharArray()[0])
					newURL = newURL + "%2F";
				else
					if (d[i] == "^".toCharArray()[0])
						newURL = newURL + "%5E";
					else
						if (d[i] == " ".toCharArray()[0])
							newURL = newURL + "+";
						else
							if (d[i] == ",".toCharArray()[0])
								newURL = newURL + ".";
							else
								newURL = newURL + String.valueOf(d[i]);
		}

		return newURL;
	}

}